/* ===================================================================
 * DeleteRecipeForm.java
 * 
 * Created Oct 18, 2004 8:41:57 AM
 * 
 * Copyright (c) 2004 Matt Magoffin (spamsqr@msqr.us)
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
 * 02111-1307 USA
 * ===================================================================
 * $Id: DeleteRecipeForm.java 4 2009-05-01 03:27:53Z msqr $
 * ===================================================================
 */

package magoffin.matt.ieat.web;

import java.util.LinkedHashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import magoffin.matt.ieat.EatValidationException;
import magoffin.matt.ieat.biz.BizContext;
import magoffin.matt.ieat.domain.Recipe;
import magoffin.matt.ieat.domain.UiSearchResults;
import magoffin.matt.ieat.util.RecipeCommand;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.web.servlet.ModelAndView;

/**
 * Form controller to delete a recipe.
 * 
 * @author Matt Magoffin (spamsqr@msqr.us)
 * @version $Revision: 4 $ $Date: 2009-05-01 15:27:53 +1200 (Fri, 01 May 2009) $
 */
public class DeleteRecipeForm extends AbstractEatForm {
	
	private String indexView;
	private String searchView;
	
	@SuppressWarnings("unchecked")
	@Override
	protected Map referenceData(HttpServletRequest request, Object command,
			Errors errors) throws Exception {
		Map<String, Object> m = new LinkedHashMap<String, Object>();
		
		UiSearchResults sr = getDomainObjectFactory().getSearchResultsInstance();
		m.put("uidata",sr);

		// add recipe
		RecipeCommand recipeCommand = (RecipeCommand)command;
		Recipe r = recipeBiz.getRecipeById(recipeCommand.getRecipeId());
		sr.getRecipe().add(r);
		
		WebUtil.initSearchResults(sr,recipeCommand.getIndex(),
				recipeCommand.getCriteria(), getDomainObjectFactory());
		
		return m;
	}
	
	@Override
	protected ModelAndView onSubmit(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception {
		RecipeCommand recipeCommand = (RecipeCommand)command;
		
		Map<String, Object> m = new LinkedHashMap<String, Object>();
		WebUtil.saveRecipeCommand(m,recipeCommand);

		BizContext context = WebUtil.getBizContext(request, false);
		try {
			recipeBiz.removeRecipe(recipeCommand.getRecipeId(),context);
		} catch ( EatValidationException e ) {
			errors.addAllErrors(e.getErrors());
			return showForm(request, response, errors);
		}
		
		String resultView = getIndexView();
		if ( recipeCommand.getCriteria() != null ) {
			resultView = getSearchView();
		}
		
		return new ModelAndView(resultView,m);
	}

	@Override
	protected ModelAndView processCancel(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors) {
		RecipeCommand recipeCommand = (RecipeCommand)command;
		Map<String, Object> m = new LinkedHashMap<String, Object>();
		WebUtil.saveRecipeCommand(m,recipeCommand);
		return new ModelAndView(getCancelView(),m);
	}
	
	/**
	 * @return Returns the indexView.
	 */
	public String getIndexView() {
		return indexView;
	}
	
	/**
	 * @param indexView The indexView to set.
	 */
	public void setIndexView(String indexView) {
		this.indexView = indexView;
	}
	
	/**
	 * @return Returns the searchView.
	 */
	public String getSearchView() {
		return searchView;
	}
	
	/**
	 * @param searchView The searchView to set.
	 */
	public void setSearchView(String searchView) {
		this.searchView = searchView;
	}
}
